scala.reflect.macros.Universe.MacroInternalApi

# MacroDecoratorApi

#### trait MacroDecoratorApi extends DecoratorApi

<invalid inheritdoc annotation>

Source
  Universe.scala

Linear Supertypes
MacroInternalApi.DecoratorApi, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. MacroDecoratorApi
2. DecoratorApi
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### class MacroScopeDecoratorApi[T <: Universe.Scope] extends AnyRef

   See also

     ScopeDecorator

2. #### class MacroSymbolDecoratorApi[T <: Universe.Symbol] extends SymbolDecoratorApi[T]

   See also

     TreeDecorator

3. #### class MacroTreeDecoratorApi[T <: Universe.Tree] extends TreeDecoratorApi[T]

   See also

     TreeDecorator

4. #### class MacroTypeTreeDecoratorApi[T <: Universe.TypeTree] extends AnyRef

   See also

     TypeTreeDecorator

5. #### abstract type ScopeDecorator[T <: Universe.Scope] <: MacroScopeDecoratorApi[T]

   Extension methods for scopes

6. #### abstract type SymbolDecorator[T <: Universe.Symbol] <: MacroSymbolDecoratorApi[T]

   Extension methods for symbols

   Extension methods for symbols

   Definition Classes
     MacroDecoratorApi → DecoratorApi

7. #### class SymbolDecoratorApi[T <: Universe.Symbol] extends AnyRef

   Definition Classes
     DecoratorApi
   See also

     SymbolDecorator

8. #### abstract type TreeDecorator[T <: Universe.Tree] <: MacroTreeDecoratorApi[T]

   Extension methods for trees

   Extension methods for trees

   Definition Classes
     MacroDecoratorApi → DecoratorApi

9. #### class TreeDecoratorApi[T <: Universe.Tree] extends AnyRef

   Definition Classes
     DecoratorApi
   See also

     TreeDecorator

10. #### abstract type TypeDecorator[T <: Universe.Type] <: TypeDecoratorApi[T]

    Extension methods for types

    Extension methods for types

    Definition Classes
      DecoratorApi

11. #### implicit class TypeDecoratorApi[T <: Universe.Type] extends AnyRef

    Definition Classes
      DecoratorApi
    See also

      TypeDecorator

12. #### abstract type TypeTreeDecorator[T <: Universe.TypeTree] <: MacroTypeTreeDecoratorApi[T]

    Extension methods for typetrees

### Abstract Value Members

1. #### implicit abstract def scopeDecorator[T <: Universe.Scope](tree: T): ScopeDecorator[T]

   See also

     ScopeDecorator

2. #### implicit abstract def symbolDecorator[T <: Universe.Symbol](symbol: T): SymbolDecorator[T]

   Definition Classes
     DecoratorApi
   See also

     SymbolDecorator

3. #### implicit abstract def treeDecorator[T <: Universe.Tree](tree: T): TreeDecorator[T]

   Definition Classes
     DecoratorApi
   See also

     TreeDecorator

4. #### implicit abstract def typeDecorator[T <: Universe.Type](tp: T): TypeDecorator[T]

   Definition Classes
     DecoratorApi
   See also

     TypeDecorator

5. #### implicit abstract def typeTreeDecorator[T <: Universe.TypeTree](tt: T): TypeTreeDecorator[T]

   See also

     TypeTreeDecorator

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from MacroDecoratorApi to any2stringadd[MacroDecoratorApi] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (MacroDecoratorApi, B)

   Implicit information
     This member is added by an implicit conversion from MacroDecoratorApi to ArrowAssoc[MacroDecoratorApi] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

8. #### def ensuring(cond: (MacroDecoratorApi) ⇒ Boolean, msg: ⇒ Any): MacroDecoratorApi

   Implicit information
     This member is added by an implicit conversion from MacroDecoratorApi to Ensuring[MacroDecoratorApi] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

9. #### def ensuring(cond: (MacroDecoratorApi) ⇒ Boolean): MacroDecoratorApi

   Implicit information
     This member is added by an implicit conversion from MacroDecoratorApi to Ensuring[MacroDecoratorApi] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: Boolean, msg: ⇒ Any): MacroDecoratorApi

    Implicit information
      This member is added by an implicit conversion from MacroDecoratorApi to Ensuring[MacroDecoratorApi] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean): MacroDecoratorApi

    Implicit information
      This member is added by an implicit conversion from MacroDecoratorApi to Ensuring[MacroDecoratorApi] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

13. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

14. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

15. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from MacroDecoratorApi to StringFormat[MacroDecoratorApi] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

16. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

17. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

18. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

19. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

20. #### final def notify(): Unit

    Definition Classes
      AnyRef

21. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

22. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

23. #### def toString(): String

    Definition Classes
      AnyRef → Any

24. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

25. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

26. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### def →[B](y: B): (MacroDecoratorApi, B)

    Implicit information
      This member is added by an implicit conversion from MacroDecoratorApi to ArrowAssoc[MacroDecoratorApi] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from MacroInternalApi.DecoratorApi

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from MacroDecoratorApi to any2stringadd[MacroDecoratorApi]

### Inherited by implicit conversion StringFormat from MacroDecoratorApi to StringFormat[MacroDecoratorApi]

### Inherited by implicit conversion Ensuring from MacroDecoratorApi to Ensuring[MacroDecoratorApi]

### Inherited by implicit conversion ArrowAssoc from MacroDecoratorApi to ArrowAssoc[MacroDecoratorApi]

### Ungrouped